﻿using System;
using System.ComponentModel;
using MVVM;

namespace CoveringArray.ViewModel
{
    public class ProgressBarViewModel : ViewModelBase
    {
        #region Properties
        public BackgroundWorker Worker
        {
            get { return _Worker ?? (_Worker = new BackgroundWorker()); }
            set { _Worker = value; }
        } private BackgroundWorker _Worker;


        public int Max
        {
            get { return _Max; }
            set
            {
                _Max = value;
                NotifyPropertyChanged("Max");
            }
        } private int _Max;

        public int Min
        {
            get { return _Min; }
            set
            {
                _Min = value;
                NotifyPropertyChanged("Min");
            }
        } private int _Min;

        public int Value
        {
            get { return _Value; }
            set
            {
                _Value = value;
                NotifyPropertyChanged("Value");
            }
        } private int _Value;

        public String Message
        {
            get { return _Message; }
            set
            {
                _Message = value;
                NotifyPropertyChanged("Message");
            }
        } private String _Message;
        #endregion
    }
}
