﻿using System.ComponentModel;

namespace CoveringArrayAlgorithm
{
    public class TestSuiteCollectionCreator
    {
        public static void Create(TestSuiteCollection inTestSuiteCollection, TestSuite inTemplate, int inNumberOfTestSuites, BackgroundWorker inWorker = null)
        {
            // Clear previous created TestSuiteColleciton
            inTestSuiteCollection.Clear();

            for (int i = 0; i < inNumberOfTestSuites; i++)
            {
                inTestSuiteCollection.Add(new TestSuite()
                    {
                        Id = i + 1,
                        NWay = inTemplate.NWay,
                        Components = inTemplate.Components,
                        OptionGroups = (inTestSuiteCollection.Count == 0) ? inTemplate.OptionGroups.Copy() : inTestSuiteCollection[i - 1].OptionGroups.Copy()
                    });

                // Report progress to a a BackgroundWorker if one exists
                if (inWorker != null)
                    inWorker.ReportProgress(i + 1);

                TestSuiteCreator.CreateTestSuite(inTestSuiteCollection[i]);
            }
        }
    }
}
