﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using CoveringArrayAlgorithm;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace CoveringArrayAlgorithm_Tests
{
    [TestClass]
    public class TestSuiteCreator_Test
    {
        [TestMethod]
        public void Constructor_GetGroups_3x3_NWay2()
        {
            // 1, 2, 3
            // 4, 5, 6
            // 7, 8, 9
            // Groups: 1, 4 1, 5 1, 6 1, 7 1, 8 1, 9  
            //         2, 4 2, 5 2, 6 2, 7 2, 8 2, 9 
            //         3, 4 3, 5 3, 6 3, 7 3, 8 3, 9
            //         4, 7 4, 8 4, 9 
            //         5, 7 5, 8 5, 9 
            //         6, 7 6, 8 6, 9

            var expectedGroups = new OptionGroups();
            expectedGroups.Add(new SortedTuple() { 1, 4 });
            expectedGroups.Add(new SortedTuple() { 1, 5 });
            expectedGroups.Add(new SortedTuple() { 1, 6 });
            expectedGroups.Add(new SortedTuple() { 1, 7 });
            expectedGroups.Add(new SortedTuple() { 1, 8 });
            expectedGroups.Add(new SortedTuple() { 1, 9 });
            expectedGroups.Add(new SortedTuple() { 2, 4 });
            expectedGroups.Add(new SortedTuple() { 2, 5 });
            expectedGroups.Add(new SortedTuple() { 2, 6 });
            expectedGroups.Add(new SortedTuple() { 2, 7 });
            expectedGroups.Add(new SortedTuple() { 2, 8 });
            expectedGroups.Add(new SortedTuple() { 2, 9 });
            expectedGroups.Add(new SortedTuple() { 3, 4 });
            expectedGroups.Add(new SortedTuple() { 3, 5 });
            expectedGroups.Add(new SortedTuple() { 3, 6 });
            expectedGroups.Add(new SortedTuple() { 3, 7 });
            expectedGroups.Add(new SortedTuple() { 3, 8 });
            expectedGroups.Add(new SortedTuple() { 3, 9 });
            expectedGroups.Add(new SortedTuple() { 4, 7 });
            expectedGroups.Add(new SortedTuple() { 4, 8 });
            expectedGroups.Add(new SortedTuple() { 4, 9 });
            expectedGroups.Add(new SortedTuple() { 5, 7 });
            expectedGroups.Add(new SortedTuple() { 5, 8 });
            expectedGroups.Add(new SortedTuple() { 5, 9 });
            expectedGroups.Add(new SortedTuple() { 6, 7 });
            expectedGroups.Add(new SortedTuple() { 6, 8 });
            expectedGroups.Add(new SortedTuple() { 6, 9 });

            TestSuite testSuite = new TestSuite();
            testSuite.Components.Add(new Component() { 1, 2, 3 });
            testSuite.Components.Add(new Component() { 4, 5, 6 });
            testSuite.Components.Add(new Component() { 7, 8, 9 });

            TestSuiteCreator.GetOptionGroups(testSuite.OptionGroups, testSuite.Components, testSuite.NWay);

            OptionGroups actualGroups = testSuite.OptionGroups;

            Assert.AreEqual(expectedGroups.Count, actualGroups.Count);

            for (int i = 0; i < expectedGroups.Count; i++)
                Assert.AreEqual(expectedGroups.ElementAt(i), actualGroups.ElementAt(i));
        }

        [TestMethod]
        public void Constructor_GetGroups_2x3_NWay3()
        {
            // 1, 2
            // 3, 4, 
            // 5, 6

            OptionGroups expectedGroups = new OptionGroups();
            expectedGroups.Add(new SortedTuple() { 1, 3, 5 });
            expectedGroups.Add(new SortedTuple() { 1, 3, 6 });
            expectedGroups.Add(new SortedTuple() { 1, 4, 5 });
            expectedGroups.Add(new SortedTuple() { 1, 4, 6 });
            expectedGroups.Add(new SortedTuple() { 2, 3, 5 });
            expectedGroups.Add(new SortedTuple() { 2, 3, 6 });
            expectedGroups.Add(new SortedTuple() { 2, 4, 5 });
            expectedGroups.Add(new SortedTuple() { 2, 4, 6 });

            TestSuite testSuite = new TestSuite() { NWay = 3 };
            testSuite.Components.Add(new Component() { 1, 2 });
            testSuite.Components.Add(new Component() { 3, 4 });
            testSuite.Components.Add(new Component() { 5, 6 });

            TestSuiteCreator.GetOptionGroups(testSuite.OptionGroups, testSuite.Components, testSuite.NWay);

            OptionGroups actualGroups = testSuite.OptionGroups;

            Assert.AreEqual(expectedGroups.Count, actualGroups.Count);

            for (int i = 0; i < expectedGroups.Count; i++)
                Assert.AreEqual(expectedGroups.ElementAt(i), actualGroups.ElementAt(i));
        }

    }
}
