﻿using System.Windows;
using CoveringArrayView.View;
using CoveringArrayView.ViewModel;

namespace CoveringArrayView
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App
    {
        private static MainWindowViewModel _MainWindowViewModel;
        private static MainWindow _MainWindow;

        protected override void OnStartup(StartupEventArgs e)
        {
            base.OnStartup(e);
            _MainWindowViewModel = new MainWindowViewModel();
            _MainWindow = new MainWindow { DataContext = _MainWindowViewModel };
            _MainWindow.Show();
        }

        public static void ManageKnownTypes()
        {
            var viewmodel = new ManageKnownTypesViewModel();
            var manageKnownTypesView = new ManagemKnownTypesView() { DataContext = _MainWindowViewModel.ManageKnownTypesViewModel };
            manageKnownTypesView.ShowDialog();
        }
    }
}
