﻿using System;

namespace CoveringArrayView.Model
{
    public class KnownType : IMapATypeToValues
    {
        public KnownType()
        {
            TestValues = new TestValueCollection(this);
        }

        public String TypeName { get; set; }

        public String ShortTypeName
        {
            get { return _ShortTypeName ?? TypeName; }
            set { _ShortTypeName = value; }
        } private string _ShortTypeName;


        public TestValueCollection TestValues
        {
            get { return _TestValues; }
            set
            {
                _TestValues = value;
                _TestValues.Parent = this;
                _TestValues.Fix();
            }
        } private TestValueCollection _TestValues;

        public KnownType Clone(string inTypeName = null, string inShortTypeName = null)
        {
            var type = new KnownType();
            type.TypeName = inTypeName ?? this.TypeName;
            type.ShortTypeName = inShortTypeName ?? ShortTypeName;
            type.TestValues = TestValues.Clone();
            return type;
        }
    }
}
