﻿using System.Collections.ObjectModel;
using System.Linq;

namespace CoveringArrayView.Model
{
    public class KnownTypeCollection : ObservableCollection<KnownType>
    {
        public KnownType UnknownType
        {
            get { return _UnkownType ?? (_UnkownType = GetUnknownType()); }
        } private KnownType _UnkownType;

        private KnownType GetUnknownType()
        {
            foreach (var type in this.Where(type => type.TypeName == "Unknown"))
            {
                return type;
            }
            // If a custom Unknown type doesn't exist, use the default one.
            return GetDefaultUnknownType();
        }

        private KnownType GetDefaultUnknownType()
        {
            var unknownType = new KnownType() { TypeName = "Unknown" };
            unknownType.TestValues.Add("Null", null);
            unknownType.TestValues.Add("Not Null", "%new%");
            return unknownType;
        }
    }
}
