﻿using CoveringArrayAlgorithm;
using CoveringArrayView.Singleton;

namespace CoveringArrayView.Model
{
    public class Parameter
    {
        public Parameter(string inTypeName, string inParameterName)
        {
            TypeName = inTypeName;
            ParameterName = inParameterName;
            bool matchFound = false;
            foreach (var type in DataStore.Instance.KnownTypeCollection)
            {
                if (type.TypeName.Equals(this.TypeName) || type.ShortTypeName.Equals(this.TypeName))
                {
                    KnownType = type.Clone();
                    matchFound = true;
                    foreach (TestValue t in type.TestValues)
                    {
                        t.Id = TestSuite.NextOptionId++;
                    }
                    break;
                }
            }
            if (!matchFound)
            {
                KnownType = DataStore.Instance.KnownTypeCollection.UnknownType.Clone(inTypeName, inTypeName);
            }
        }

        public string TypeName { get; set; }

        public string ParameterName { get; set; }

        public KnownType KnownType { get; set; }
    }
}
