﻿using System;
using System.Collections.ObjectModel;

namespace CoveringArrayView.Model
{
    [Serializable]
    public class TestValueCollection : ObservableCollection<TestValue>
    {
        private static int _counter;

        public TestValueCollection()
        {
        }

        public TestValueCollection(KnownType inParent)
        {
            Parent = inParent;
        }

        public KnownType Parent { get; set; }

        public void Add(String inName, String inValue)
        {
            Add(new TestValue(Parent) { Name = inName, Value = inValue });
            Fix();
        }

        public TestValueCollection Clone()
        {
            Fix();
            var col = new TestValueCollection() { Parent = this.Parent };
            foreach (var tv in this)
            {
                col.Add(tv.Clone());
            }
            return col;
        }

        public void Fix()
        {
            _counter = 0;
            foreach (var testValue in this)
            {
                testValue.Id = _counter++;
                testValue.SetParent(Parent);
            }
        }
    }
}
