﻿using System.Windows;
using System.Windows.Input;
using CoveringArrayView.Singleton;
using MVVM;

namespace CoveringArrayView.ViewModel
{
    public class MainMenuViewModel : ViewModelBase
    {
        #region Properties
        public int[] NWayOptions
        {
            get { return _NWayOptions ?? (_NWayOptions = new[] { 2, 3 }); }
            set
            {
                _NWayOptions = value;
                NotifyPropertyChanged("NWayOptions");
            }
        } private int[] _NWayOptions;

        public int NWay
        {
            get { return DataStore.Instance.NWay; }
            set
            {
                DataStore.Instance.NWay = value;
                NotifyPropertyChanged("NWay");
            }
        }

        public string[] TestFrameworks
        {
            get { return _TestFrameworks ?? (_TestFrameworks = new[] { "MSTest" }); } // Todo: Add NUnit support
            set
            {
                _TestFrameworks = value;
                NotifyPropertyChanged("TestFrameworks");
            }
        } private string[] _TestFrameworks;

        public string TestFramework
        {
            get { return DataStore.Instance.TestFramework; }
            set
            {
                DataStore.Instance.TestFramework = value;
                NotifyPropertyChanged("TestFramework");
            }
        }

        public ICommand ExitCommand
        {
            get { return _ExitCommand ?? (_ExitCommand = new RelayCommand(f => Exit())); }
            set
            {
                _ExitCommand = value;
                NotifyPropertyChanged("ExitCommand");
            }
        } private ICommand _ExitCommand;

        public ICommand ManageKnownTypesCommand
        {
            get { return _ManageKnownTypesCommand ?? (_ManageKnownTypesCommand = new RelayCommand(f => ManageKnownTypes())); }
            set
            {
                _ManageKnownTypesCommand = value;
                NotifyPropertyChanged("ManageKnownTypesCommand");
            }
        } private ICommand _ManageKnownTypesCommand;
        #endregion

        #region Methods
        private void Exit()
        {
            Application.Current.Shutdown(0);
        }

        private void ManageKnownTypes()
        {
            App.ManageKnownTypes();
        }
        #endregion
    }
}
