﻿using System.Collections.Generic;
using MVVM;

namespace CoveringArrayView.ViewModel
{
    class MainWindowViewModel : ViewModelBase
    {
        #region Member Variables
        private List<ViewModelBase> _ViewModels;
        #endregion

        #region Constructors
        /// <summary>
        /// The default constructor
        /// </summary>
        public MainWindowViewModel()
        {
            ViewModels.Add(new MainMenuViewModel());
            ViewModels.Add(new FunctionViewModel());
            ManageKnownTypesViewModel = new ManageKnownTypesViewModel();
        }
        #endregion

        #region Properties
        public List<ViewModelBase> ViewModels
        {
            get
            {
                if (_ViewModels == null)
                    _ViewModels = new List<ViewModelBase>();
                return _ViewModels;
            }
        }

        public ManageKnownTypesViewModel ManageKnownTypesViewModel { get; set; }
        #endregion
    }
}
